SystemOrganization addCategory: 'OrbeonLDAP'!

Object subclass: #OrbeonLoginMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonLDAP'!

OrbeonLoginMode subclass: #OrbeonLdapLogin
	instanceVariableNames: 'ldapIP dn ou bindPassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonLDAP'!

!OrbeonLdapLogin commentStamp: '' prior: 0!
ldapIP 				- 10.255.5.111
dn 					- "cn=admin.orbeon,C=UY"
ou					- "uid=username ou=usuarios,cn=orbeon-test,C=UY"
bindPassword	- myPassword


	^(System performOnServer:
		'ldapcompare -x -D "cn=admin.orbeon,C=UY" -H ldap://10.255.5.111 "uid=', name,',ou=usuarios,cn=orbeon-test,C=UY" -w orbeon1999  userpassword:', password) trimBlanks!

!OrbeonLdapLogin class methodsFor: 'other' stamp: 'BrunoBB 03/15/2015 15:59'!
modeName

	^'LDAP'! !

!OrbeonLdapLogin methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2015 12:01'!
bindPassword

   "Return the value of the instance variable 'bindPassword'."
   ^bindPassword! !

!OrbeonLdapLogin methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2015 12:01'!
bindPassword: newValue

   "Modify the value of the instance variable 'bindPassword'."
   bindPassword := newValue! !

!OrbeonLdapLogin methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2015 12:01'!
dn

   "Return the value of the instance variable 'dn'."
   ^dn! !

!OrbeonLdapLogin methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2015 12:01'!
dn: newValue

   "Modify the value of the instance variable 'dn'."
   dn := newValue! !

!OrbeonLdapLogin methodsFor: 'other' stamp: 'BrunoBB 03/15/2015 15:43'!
isLdapMode

	^true! !

!OrbeonLdapLogin methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2015 12:01'!
ldapIP

   "Return the value of the instance variable 'ldapIP'."
   ^ldapIP! !

!OrbeonLdapLogin methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2015 12:01'!
ldapIP: newValue

   "Modify the value of the instance variable 'ldapIP'."
   ldapIP := newValue! !

!OrbeonLdapLogin methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2015 12:04'!
ou

   "Return the value of the instance variable 'ou'."
   ^ou! !

!OrbeonLdapLogin methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2015 12:04'!
ou: newValue

   "Modify the value of the instance variable 'ou'."
   ou := newValue! !

!OrbeonLdapLogin methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 08:04'!
validateUser: username password: password

	^System validatePasswordUsingLdapServers: (Array with: 'ldap://', ldapIP	)
		baseDn: dn 
		filterDn: '(uid=%s)'
		userId: username 
		password: password 
		bindDn: ou
		bindPassword: bindPassword! !

OrbeonLoginMode subclass: #OrbeonLocalLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonLDAP'!

!OrbeonLocalLogin class methodsFor: 'other' stamp: 'BrunoBB 03/16/2015 16:00'!
modeName

	^'Local'! !

OrbeonLocalLogin subclass: #OrbeonProcessWebLocalLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonLDAP'!

OrbeonLocalLogin subclass: #OrbeonWebLocalLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonLDAP'!

!OrbeonLoginMode methodsFor: 'other' stamp: 'BrunoBB 03/15/2015 15:42'!
isLdapMode

	^false! !

!OrbeonLoginMode methodsFor: 'other' stamp: 'BrunoBB 03/15/2015 15:59'!
modeName

	^self class modeName! !

!GemStoneServerConfiguration methodsFor: '*orbeonLDAP' stamp: 'BrunoBB 02/03/2016 10:26'!
setLdapFor: webAppName

	(loginModes at: webAppName) isLdapMode 
	ifTrue: [^loginModes at: webAppName]. "if current is LdapMode --> nothing to do"

	^loginModes at: webAppName put: OrbeonLdapLogin new! !

!GemStoneServerConfiguration methodsFor: '*orbeonLDAP' stamp: 'BrunoBB 02/03/2016 09:16'!
setLocalForOrbeon

	^loginModes at: 'orbeon-web' put: OrbeonWebLocalLogin new! !

!GemStoneServerConfiguration methodsFor: '*orbeonLDAP' stamp: 'BrunoBB 02/03/2016 09:16'!
setLocalForProcesses

	^loginModes at: 'orbeon-processes-web' put: OrbeonProcessWebLocalLogin new! !
